package org.processmining.logdecomposer.classifiers;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XVisitor;
import org.processmining.logdecomposer.extensions.XClassExtension;

public class StartEndClassifier implements XEventClassifier {

	private XEventClassifier classifier;
	
	public StartEndClassifier(XEventClassifier classifier) {
		this.classifier = classifier;
	}
	
	public void accept(XVisitor arg0, XLog arg1) {
		classifier.accept(arg0, arg1);
	}

	public String getClassIdentity(XEvent arg0) {
		String classid = XClassExtension.instance().extractEventId(arg0);
		if (classid == null) {
			classid = classifier.getClassIdentity(arg0);
		}
		return classid;
	}

	public String[] getDefiningAttributeKeys() {
		return classifier.getDefiningAttributeKeys();
	}

	public String name() {
		return classifier.name() + " (w/ artifical Start and End events)";
	}

	public boolean sameEventClass(XEvent arg0, XEvent arg1) {
		return false;
	}

	public void setName(String arg0) {
		classifier.setName(arg0);
	}

	public String toString() {
		return name();
	}
}
